﻿local COLOR_WHITE = "ffffff"
local COLOR_COPPER = "eda55f"
local COLOR_SILVER = "c7c7cf"
local COLOR_GOLD = "ffd700"

local EnchantBot_Mode_OwnMatsTips, EnchantBot_Mode_SellWithMats = 1, 2

EnchantBot_On = false
EnchantBot_AM_Support = true
EnchantBot_Mode = EnchantBot_Mode_OwnMatsTips

function EnchantBot_OnLoad()
	--if (not EnchantBot_IsEnchanter()) then
	--	UIErrorsFrame:AddMessage("EnchantBot is for Enchanters Only", 1.0, 1.0, 0.0, 1.0, 10)
	--	return
	--end
	EnchantBot:RegisterEvent("CHAT_MSG_WHISPER")
	SlashCmdList["ENCHANTBOT"] = EnchantBot_SlashHandler
	SLASH_ENCHANTBOT1 = "/enchantbot"
	SLASH_ENCHANTBOT2 = "/eb"
	CountIt = 0
end

function EnchantBot_SlashHandler(msg)
	local words = {}
	for word in string.gmatch(msg, "%w+") do
		table.insert(words, word)
	end
	if (table.getn(words)) then
		local cmd = words[1]
		if (cmd == "on") then
			EnchantBot_Activate(true)
		elseif (cmd == "off") then
			EnchantBot_Activate(false)
		elseif (cmd == "am") then
			local param = words[2]
			if (param == "on") then
				EnchantBot_AM_Support = true
				DEFAULT_CHAT_FRAME:AddMessage("EnchantBot's AutoMessage support is On")
			elseif (param == "off") then
				EnchantBot_AM_Support = false
				DEFAULT_CHAT_FRAME:AddMessage("EnchantBot's AutoMessage support is Off")
			elseif (param == "set") then
				EnchantBot_AM_SetMessage()
			end
		elseif (cmd == "mode") then
			local param = words[2]
			if (param == "sell") then
				EnchantBot_Mode_Change(EnchantBot_Mode_SellWithMats)
			elseif (param == "tips") then
				EnchantBot_Mode_Change(EnchantBot_Mode_OwnMatsTips)
			end
		end
	else
		EnchantBot_Activate(not EnchantBot_On)
	end
end

function EnchantBot_Mode_Change(mode)
	EnchantBot_Open_EnchantWnd()
	EnchantBot_Mode = mode
	if (EnchantBot_AM_Support and IsAddOnLoaded("AutoMessage") and GetNumCrafts()) then
		EnchantBot_AM_SetMessage()
	end
	if (mode == EnchantBot_Mode_SellWithMats) then
		DEFAULT_CHAT_FRAME:AddMessage("EnchantBot's mode is Sell")
	else
		DEFAULT_CHAT_FRAME:AddMessage("EnchantBot's mode is Tips")
	end
end

function EnchantBot_Activate(state)
	if (state) then
		EnchantBot_Open_EnchantWnd()
		EnchantBot_On = true
		EnchantBot:RegisterEvent("CHAT_MSG_WHISPER")
		DEFAULT_CHAT_FRAME:AddMessage("EnchantBot is On")

		-- starts AutoMessage
		if (EnchantBot_AM_Support and IsAddOnLoaded("AutoMessage") and GetNumCrafts()) then
			EnchantBot_AM_SetMessage()
			if (stopit == 1) then
				runtick = GetTime()
				stopit = 0
			end
		end
	else
		EnchantBot_On = false
		EnchantBot:UnregisterEvent("CHAT_MSG_WHISPER")
		DEFAULT_CHAT_FRAME:AddMessage("EnchantBot is Off")

		if (EnchantBot_AM_Support and IsAddOnLoaded("AutoMessage")) then
			stopit = 1
		end
	end
end

function SendChat(user, text)
	if (user == UnitName("player")) then
		DEFAULT_CHAT_FRAME:AddMessage(text)
	else
		SendChatMessage(text, "WHISPER", GetDefaultLanguage("player"), user)
	end
end

function EnchantBot_Open_EnchantWnd()
	-- opens Enchanting window if not already open, but only works the first time!
	if (GetCraftSkillLine(1) ~= "Enchanting") then
		CastSpellByName("Enchanting")
	end
end

function EnchantBot_AM_SetMessage()
	local am_msg = "Enchants"
	local am_postfix
	if (EnchantBot_Mode == EnchantBot_Mode_SellWithMats) then
		am_postfix = " PST 'ebhelp' for more."
	else
		am_postfix = " Bring Mats+Tips PST 'ebhelp' for more."
	end
	local am_postfix_len = strlen(am_postfix)
	local craftNos = GetNumCrafts() - 1
	-- greater priority to special (valuable?) enchants below, but not barked as craftlinks
	for i = 1, craftNos do
		local craftName, _, _, _, _ = GetCraftInfo(i)
		craftName = strlower(craftName)
		if (string.find(craftName, "fiery")) then
			am_msg = am_msg .. " Fiery"
		elseif (string.find(craftName, "crusader")) then
			am_msg = am_msg .. " Crusader"
		elseif (string.find(craftName, "unholy")) then
			am_msg = am_msg .. " Unholy"
		elseif (string.find(craftName, "icy chill")) then
			am_msg = am_msg .. " Icy"
		elseif (string.find(craftName, "lifestealing")) then
			am_msg = am_msg .. " Lifestealing"
		end
	end
	-- normal priority enchants below till max length i.e. 255, barked as craftlinks
	for i = 1, craftNos do
		local craftLink = " " .. GetCraftItemLink(i)
		if (strlen(craftLink) + strlen(am_msg) + am_postfix_len <= 255) then
			am_msg = am_msg .. craftLink
		else
			break
		end
	end
	am = am_msg .. am_postfix
end

function EnchantBot_OnEvent()

	if(event == "CHAT_MSG_WHISPER") then

		user = arg2

		if(arg1 == "ebhelp" or arg1 == "ebsearch") then
			local greetings = "Welcome to "..UnitName("player").."\'s Enchanting Shoppe!"
			local help = "Whisper me \"ebsearch\" followed by a part of the enchant's name/desc (+9 Str, Agility, Weapon, 2H Weap, Resist, Cloak...) to browse e.g. \"ebsearch fiery\""
			if (EnchantBot_Mode == EnchantBot_Mode_OwnMatsTips) then
				greetings = greetings .. " Remember to bring your own reagents and tips!"
			end
			SendChat(user, greetings)
			SendChat(user, help)
			return
		end

		local X = 0
		local tmp2 = strlower(arg1)
		local Y = nil

		--strip "ebsearch " from the string
		local p, n = string.find(tmp2, "ebsearch ")
		if(p == nil and n == nil) then
			local p, n = string.find(tmp2, "ebfind ")
			if(p == nil and n == nil) then
				local p, n = string.find(tmp2, "ebreagents ")
				if(p == nil and n == nil) then
					local p, n = string.find(tmp2, "ebmats ")
					if(p == nil and n == nil) then
						return
					else
						local Z = string.sub(tmp2, n, strlen(tmp2))
						Y = tonumber(Z)
					end
				else
					local Z = string.sub(tmp2, n, strlen(tmp2))
					Y = tonumber(Z)
				end
			else
				tmp2 = string.sub(tmp2, n, strlen(tmp2))
				Y = nil
			end
		else
			tmp2 = string.sub(tmp2, n, strlen(tmp2))
			Y = nil
		end

		EnchantBot_Open_EnchantWnd()

		if(Y == nil) then -- requesting search of description and recipe name
			for i=1, GetNumCrafts()-1 do
				local tmp1, tmp3, foo2 = nil, nil, nil
				local craftName, craftSubSpellName, craftType, numAvailable, isExpanded = GetCraftInfo(i)
				local desc, two, three = GetCraftDescription(i)
				tmp1 = strlower(craftName)
				local foo = string.find(tmp1,tmp2)

				if(desc ~= nil) then
					tmp3 = strlower(desc)
					foo2 = string.find(tmp3,tmp2)
				end

				if(foo ~= nil or foo2 ~= nil) then
					X = 1
					CountIt = CountIt + 1
					local result = "[" .. i .. "] " .. GetCraftItemLink(i)
					-- Sell Mode. Don't return as result if player cannot make it.
					if (EnchantBot_Mode == EnchantBot_Mode_SellWithMats) then
						if (numAvailable > 0) then
							result = result .. EnchantBot_GetBarkerPrice(i)
						else
							result = ""
						end
					end
					if (result ~= "") then
						SendChat(user, result)
					end
				end
			end

			if(X == 1) then
				SendChat(user,"Check the link given for the reagents or whisper \"ebreagents <number>\" !")
				if(user ~= UnitName("player")) then
					DEFAULT_CHAT_FRAME:AddMessage("Request on " .. arg1 .. " by " .. user .. ". "..CountIt.." results found.")
				end
			else
				SendChat(user, "No matches found for that query, try refining your request. Whisper me ebhelp for help.")
				if(user ~= UnitName("player")) then
					DEFAULT_CHAT_FRAME:AddMessage("Request on " .. arg1 .. " by " .. user .. ". No result found.")
				end
			end

			CountIt = 0

		else --requesting ingredients
			local reagents = " "
			local rtmp = nil
			local foo = false
			for m=1, GetCraftNumReagents(Y) do
				local reagentName, reagentTexture, reagentCount, playerReagentCount = GetCraftReagentInfo(Y, m)

				rtmp = reagents .. " " .. reagentCount .. "x " .. GetCraftReagentItemLink(Y,m)
				if(strlen(rtmp) > 255) then
					SendChat(user, "Reagents for " .. GetCraftItemLink(Y,m) .. " :")
					SendChat(user, reagents)

					rtmp = "(continued) " .. reagentCount .. "x" .. GetCraftReagentItemLink(Y,m)
					reagents = rtmp
					foo = true
				end
				reagents = rtmp
			end
			local craftName, craftSubSpellName, craftType, numAvailable, isExpanded = GetCraftInfo(Y)

			SendChat(user, "Reagents for " .. GetCraftItemLink(Y,m) .. " :")
			SendChat(user, reagents)
		end
	end -- if(event == "CHAT_MSG_WHISPER")
end

function EnchantBot_GetBarkerPrice(craftIndex)

	if (EnchantBot_Mode ~= EnchantBot_Mode_SellWithMats or not craftIndex) then
		return ""
	end

	local loaded, reason = LoadAddOn("Enchantrix")
	if (not loaded) then
		DEFAULT_CHAT_FRAME:AddMessage("Can't load Enchantrix: "..reason)
		return ""
	else
		-- Get reagent list
		local reagentList = {}
		local numReagents = GetCraftNumReagents(craftIndex)
		for i = 1, numReagents do
			local link = GetCraftReagentItemLink(craftIndex, i)
			if link then
				local hlink = EnhTooltip.HyperlinkFromLink(link)
				local reagentName, reagentTexture, reagentCount, playerReagentCount = GetCraftReagentInfo(craftIndex, i)
				table.insert(reagentList, {hlink, reagentCount})
			end
		end

		if not reagentList or table.getn(reagentList) < 1 then
			return ""
		end

		-- Append additional reagent info
		for _, reagent in ipairs(reagentList) do
			local name, link, quality = Enchantrix.Util.GetReagentInfo(reagent[1])
			local hsp, median, market = Enchantrix.Util.GetReagentPrice(reagent[1])
			local _, _, _, color = GetItemQualityColor(quality)

			reagent[1] = name
			table.insert(reagent, quality)
			table.insert(reagent, color)
			table.insert(reagent, hsp)
		end

		local NAME, COUNT, QUALITY, COLOR, PRICE = 1, 2, 3, 4, 5

		-- Sort by rarity and price
		table.sort(reagentList, function(a,b)
			if (not b) or (not a) then return end
			return ((b[QUALITY] or -1) < (a[QUALITY] or -1)) or ((b[PRICE] or 0) < (a[PRICE] or 0))
		end)

		local price = 0
		local unknownPrices
		-- Add reagent list to tooltip and sum reagent prices
		for _, reagent in pairs(reagentList) do
			local line = "  "

			if reagent[COLOR] then
				line = line..reagent[COLOR]
			end
			line = line..reagent[NAME]
			if reagent[COLOR] then
				line = line.."|r"
			end
			line = line.." x"..reagent[COUNT]
			if reagent[COUNT] > 1 and reagent[PRICE] then
				line = line.." "..string.format(_ENCH('FrmtPriceEach'), EnhTooltip.GetTextGSC(Enchantrix.Util.Round(reagent[PRICE], 3)))
				price = price + reagent[PRICE] * reagent[COUNT]
			elseif reagent[PRICE] then
				price = price + reagent[PRICE]
			else
				unknownPrices = true
			end
		end

		-- Barker price
		local margin = Enchantrix_BarkerGetConfig("profit_margin")
		local profit = price * margin * 0.01
		profit = math.min(profit, Enchantrix_BarkerGetConfig("highest_profit"))
		local barkerPrice = Enchantrix_RoundPrice(price + profit)

		-- Totals
		if price > 0 then
			return " " .. EnchantBot_FormatMoney(barkerPrice)
		else
			return " ASK"
		end
	end

end

-- Support Functions

function EnchantBot_IsEnchanter()
	-- needs SkillFrame to be opened
	local skillIndex, skillName

	for skillIndex=1, GetNumSkillLines() do
		skillName = GetSkillLineInfo(skillIndex)
		if (skillName=="Enchanting") then
			return true
		end
	end
	return false
end

function EnchantBot_FormatMoney(amt)
	local gold = 0
	local silver = 0
	local copper = 0
	local formattedMoney = ""

	if amt < 100 then
		copper = amt
		if copper ~= 0 then
			formattedMoney = format("|cff%s%02d|r|cff%s%s|r", COLOR_WHITE, copper, COLOR_COPPER,"c")
		end
	else
		copper = mod(amt, 100)
		if copper ~= 0 then
			formattedMoney = format("|cff%s%02d|r|cff%s%s|r", COLOR_WHITE, copper, COLOR_COPPER,"c")
		end
		amt = amt - copper
		if amt < 10000 then
			silver = amt/100
			if silver ~= 0 then
				formattedMoney = format("|cff%s%02d|r|cff%s%s|r", COLOR_WHITE, silver, COLOR_SILVER,"s ") .. formattedMoney
			end
		else
			silver = mod(amt, 10000) / 100
			if silver ~= 0 then
				formattedMoney = format("|cff%s%02d|r|cff%s%s|r", COLOR_WHITE, silver, COLOR_SILVER,"s ") .. formattedMoney
				gold = (amt - (silver * 100))/ 10000
				formattedMoney = format("|cff%s%d|r|cff%s%s|r", COLOR_WHITE, gold, COLOR_GOLD,"g ") .. formattedMoney
			end
		end
	end
	return formattedMoney
end